/* window.c generated by valac 0.56.17, the Vala compiler
 * generated from window.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2024 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libportal/portal.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <libportal-gtk4/portal-gtk4.h>

#define CONFIG_APP_NAME "Haguichi"
#define CONFIG_APP_ID "com.github.ztefn.haguichi"
#define CONFIG_VERSION "1.5.0"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define HAGUICHI_TYPE_WINDOW (haguichi_window_get_type ())
#define HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindow))
#define HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))
#define HAGUICHI_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_WINDOW))
#define HAGUICHI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_WINDOW, HaguichiWindowClass))

typedef struct _HaguichiWindow HaguichiWindow;
typedef struct _HaguichiWindowClass HaguichiWindowClass;
typedef struct _HaguichiWindowPrivate HaguichiWindowPrivate;

#define HAGUICHI_TYPE_SIDEBAR (haguichi_sidebar_get_type ())
#define HAGUICHI_SIDEBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_SIDEBAR, HaguichiSidebar))
#define HAGUICHI_SIDEBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_SIDEBAR, HaguichiSidebarClass))
#define HAGUICHI_IS_SIDEBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_SIDEBAR))
#define HAGUICHI_IS_SIDEBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_SIDEBAR))
#define HAGUICHI_SIDEBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_SIDEBAR, HaguichiSidebarClass))

typedef struct _HaguichiSidebar HaguichiSidebar;
typedef struct _HaguichiSidebarClass HaguichiSidebarClass;

#define HAGUICHI_TYPE_NETWORK_LIST (haguichi_network_list_get_type ())
#define HAGUICHI_NETWORK_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_NETWORK_LIST, HaguichiNetworkList))
#define HAGUICHI_NETWORK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_NETWORK_LIST, HaguichiNetworkListClass))
#define HAGUICHI_IS_NETWORK_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_NETWORK_LIST))
#define HAGUICHI_IS_NETWORK_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_NETWORK_LIST))
#define HAGUICHI_NETWORK_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_NETWORK_LIST, HaguichiNetworkListClass))

typedef struct _HaguichiNetworkList HaguichiNetworkList;
typedef struct _HaguichiNetworkListClass HaguichiNetworkListClass;
enum  {
	HAGUICHI_WINDOW_0_PROPERTY,
	HAGUICHI_WINDOW_NUM_PROPERTIES
};
static GParamSpec* haguichi_window_properties[HAGUICHI_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define HAGUICHI_TYPE_APPLICATION (haguichi_application_get_type ())
#define HAGUICHI_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_APPLICATION, HaguichiApplication))
#define HAGUICHI_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_APPLICATION, HaguichiApplicationClass))
#define HAGUICHI_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_APPLICATION))
#define HAGUICHI_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_APPLICATION))
#define HAGUICHI_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_APPLICATION, HaguichiApplicationClass))

typedef struct _HaguichiApplication HaguichiApplication;
typedef struct _HaguichiApplicationClass HaguichiApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define HAGUICHI_TYPE_INDICATOR (haguichi_indicator_get_type ())
#define HAGUICHI_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_INDICATOR, HaguichiIndicator))
#define HAGUICHI_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_INDICATOR, HaguichiIndicatorClass))
#define HAGUICHI_IS_INDICATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_INDICATOR))
#define HAGUICHI_IS_INDICATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_INDICATOR))
#define HAGUICHI_INDICATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_INDICATOR, HaguichiIndicatorClass))

typedef struct _HaguichiIndicator HaguichiIndicator;
typedef struct _HaguichiIndicatorClass HaguichiIndicatorClass;
#define _haguichi_indicator_unref0(var) ((var == NULL) ? NULL : (var = (haguichi_indicator_unref (var), NULL)))

#define HAGUICHI_TYPE_SESSION (haguichi_session_get_type ())
#define HAGUICHI_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_SESSION, HaguichiSession))
#define HAGUICHI_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_SESSION, HaguichiSessionClass))
#define HAGUICHI_IS_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_SESSION))
#define HAGUICHI_IS_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_SESSION))
#define HAGUICHI_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_SESSION, HaguichiSessionClass))

typedef struct _HaguichiSession HaguichiSession;
typedef struct _HaguichiSessionClass HaguichiSessionClass;

#define HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG (haguichi_join_create_network_dialog_get_type ())
#define HAGUICHI_JOIN_CREATE_NETWORK_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG, HaguichiJoinCreateNetworkDialog))
#define HAGUICHI_JOIN_CREATE_NETWORK_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG, HaguichiJoinCreateNetworkDialogClass))
#define HAGUICHI_IS_JOIN_CREATE_NETWORK_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG))
#define HAGUICHI_IS_JOIN_CREATE_NETWORK_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG))
#define HAGUICHI_JOIN_CREATE_NETWORK_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_JOIN_CREATE_NETWORK_DIALOG, HaguichiJoinCreateNetworkDialogClass))

typedef struct _HaguichiJoinCreateNetworkDialog HaguichiJoinCreateNetworkDialog;
typedef struct _HaguichiJoinCreateNetworkDialogClass HaguichiJoinCreateNetworkDialogClass;

#define HAGUICHI_TYPE_ATTACH_DIALOG (haguichi_attach_dialog_get_type ())
#define HAGUICHI_ATTACH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_ATTACH_DIALOG, HaguichiAttachDialog))
#define HAGUICHI_ATTACH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_ATTACH_DIALOG, HaguichiAttachDialogClass))
#define HAGUICHI_IS_ATTACH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_ATTACH_DIALOG))
#define HAGUICHI_IS_ATTACH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_ATTACH_DIALOG))
#define HAGUICHI_ATTACH_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_ATTACH_DIALOG, HaguichiAttachDialogClass))

typedef struct _HaguichiAttachDialog HaguichiAttachDialog;
typedef struct _HaguichiAttachDialogClass HaguichiAttachDialogClass;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

#define HAGUICHI_TYPE_PREFERENCES (haguichi_preferences_get_type ())
#define HAGUICHI_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferences))
#define HAGUICHI_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferencesClass))
#define HAGUICHI_IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_PREFERENCES))
#define HAGUICHI_IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_PREFERENCES))
#define HAGUICHI_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_PREFERENCES, HaguichiPreferencesClass))

typedef struct _HaguichiPreferences HaguichiPreferences;
typedef struct _HaguichiPreferencesClass HaguichiPreferencesClass;

#define HAGUICHI_TYPE_CONNECTION (haguichi_connection_get_type ())
#define HAGUICHI_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), HAGUICHI_TYPE_CONNECTION, HaguichiConnection))
#define HAGUICHI_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HAGUICHI_TYPE_CONNECTION, HaguichiConnectionClass))
#define HAGUICHI_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HAGUICHI_TYPE_CONNECTION))
#define HAGUICHI_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HAGUICHI_TYPE_CONNECTION))
#define HAGUICHI_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), HAGUICHI_TYPE_CONNECTION, HaguichiConnectionClass))

typedef struct _HaguichiConnection HaguichiConnection;
typedef struct _HaguichiConnectionClass HaguichiConnectionClass;
typedef struct _HaguichiSidebarPrivate HaguichiSidebarPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _HaguichiWindowSetBackgroundStatusData HaguichiWindowSetBackgroundStatusData;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define __vala_XdpParent_free0(var) ((var == NULL) ? NULL : (var = (_vala_XdpParent_free (var), NULL)))
typedef struct _HaguichiWindowRequestBackgroundData HaguichiWindowRequestBackgroundData;

struct _HaguichiWindow {
	AdwApplicationWindow parent_instance;
	HaguichiWindowPrivate * priv;
	AdwOverlaySplitView* split_view;
	AdwWindowTitle* window_title;
	AdwStatusPage* not_installed_status_page;
	HaguichiSidebar* sidebar;
	HaguichiNetworkList* network_list;
	GtkToggleButton* connect_button;
	GtkToggleButton* disconnect_button;
	GtkToggleButton* search_button;
	GtkSearchBar* search_bar;
	GtkSearchEntry* search_entry;
	GtkStack* stack;
	GtkStack* connected_stack;
	GtkSpinner* spinner;
	GtkWindow* modal_dialog;
};

struct _HaguichiWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _HaguichiWindowPrivate {
	AdwToastOverlay* toast_overlay;
	GtkButton* refresh_button;
	GtkButton* configure_button;
	GtkButton* overlay_refresh_button;
	GtkMenuButton* overlay_add_network_button;
	XdpPortal* portal;
};

struct _HaguichiSidebar {
	AdwBin parent_instance;
	HaguichiSidebarPrivate * priv;
	GtkButton* attach_button;
	GtkButton* cancel_button;
	GtkButton* network_leave_button;
	GtkButton* network_delete_button;
	GtkButton* network_password_button;
	GtkButton* network_access_button;
	GtkButton* network_go_online_button;
	GtkButton* network_go_offline_button;
	GtkButton* member_approve_button;
	GtkButton* member_reject_button;
	GtkButton* member_evict_button;
};

struct _HaguichiSidebarClass {
	AdwBinClass parent_class;
};

struct _HaguichiWindowSetBackgroundStatusData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	HaguichiWindow* self;
	gboolean success;
	XdpPortal* _tmp0_;
	AdwWindowTitle* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

struct _HaguichiWindowRequestBackgroundData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	HaguichiWindow* self;
	gboolean result;
	XdpParent* parent;
	XdpParent* _tmp0_;
	GPtrArray* command;
	GPtrArray* _tmp1_;
	gboolean _tmp2_;
	XdpPortal* _tmp3_;
	GPtrArray* _tmp4_;
	GError* e;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_;
};

static gint HaguichiWindow_private_offset;
static gpointer haguichi_window_parent_class = NULL;
VALA_EXTERN gchar* haguichi_current_desktop;
VALA_EXTERN gboolean haguichi_demo_mode;
VALA_EXTERN HaguichiIndicator* haguichi_indicator;
VALA_EXTERN HaguichiSession* haguichi_session;
VALA_EXTERN gint haguichi_controller_last_status;
VALA_EXTERN HaguichiApplication* haguichi_app;
VALA_EXTERN HaguichiConnection* haguichi_connection;
VALA_EXTERN gchar* haguichi_hamachi_version;

VALA_EXTERN GType haguichi_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiWindow, g_object_unref)
VALA_EXTERN GType haguichi_sidebar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiSidebar, g_object_unref)
VALA_EXTERN GType haguichi_network_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiNetworkList, g_object_unref)
VALA_EXTERN GType haguichi_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiApplication, g_object_unref)
VALA_EXTERN HaguichiWindow* haguichi_window_new (HaguichiApplication* app);
VALA_EXTERN HaguichiWindow* haguichi_window_construct (GType object_type,
                                           HaguichiApplication* app);
VALA_EXTERN gchar* haguichi_utils_parse_nick (const gchar* nick);
VALA_EXTERN void haguichi_window_set_nick (HaguichiWindow* self,
                               const gchar* nick);
VALA_EXTERN void haguichi_application_set_color_scheme (HaguichiApplication* self,
                                            gint scheme);
VALA_EXTERN HaguichiIndicator* haguichi_indicator_new (void);
VALA_EXTERN HaguichiIndicator* haguichi_indicator_construct (GType object_type);
VALA_EXTERN gpointer haguichi_indicator_ref (gpointer instance);
VALA_EXTERN void haguichi_indicator_unref (gpointer instance);
VALA_EXTERN GParamSpec* haguichi_param_spec_indicator (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void haguichi_value_set_indicator (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void haguichi_value_take_indicator (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer haguichi_value_get_indicator (const GValue* value);
VALA_EXTERN GType haguichi_indicator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiIndicator, haguichi_indicator_unref)
VALA_EXTERN void haguichi_indicator_set_active (HaguichiIndicator* self,
                                    gboolean value);
VALA_EXTERN void haguichi_window_update_indicator_status (HaguichiWindow* self);
static void __lambda127_ (HaguichiWindow* self);
VALA_EXTERN void haguichi_network_list_refilter (HaguichiNetworkList* self);
static void ___lambda127__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                    gpointer self);
static void __lambda128_ (HaguichiWindow* self);
VALA_EXTERN GType haguichi_session_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiSession, g_object_unref)
VALA_EXTERN guint haguichi_session_register_object (void* object,
                                        GDBusConnection* connection,
                                        const gchar* path,
                                        GError** error);
static void ___lambda128__gtk_widget_hide (GtkWidget* _sender,
                                    gpointer self);
static void __lambda129_ (HaguichiWindow* self);
static void ___lambda129__gtk_widget_show (GtkWidget* _sender,
                                    gpointer self);
static void haguichi_window_download_hamachi (HaguichiWindow* self);
VALA_EXTERN void haguichi_command_open_redirect_uri (const gchar* action);
static void _haguichi_window_download_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void haguichi_window_configure_hamachi (HaguichiWindow* self);
VALA_EXTERN void haguichi_hamachi_configure (void);
static void _haguichi_window_configure_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void haguichi_window_go_back_button_clicked (HaguichiWindow* self);
static void _haguichi_window_go_back_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
VALA_EXTERN void haguichi_window_connect_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_start_hamachi (void);
VALA_EXTERN void haguichi_window_disconnect_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_stop_hamachi (void);
VALA_EXTERN void haguichi_window_join_network_action (HaguichiWindow* self);
static void haguichi_window_add_network_action (HaguichiWindow* self,
                                         const gchar* mode);
VALA_EXTERN void haguichi_window_create_network_action (HaguichiWindow* self);
VALA_EXTERN GType haguichi_join_create_network_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiJoinCreateNetworkDialog, g_object_unref)
VALA_EXTERN HaguichiJoinCreateNetworkDialog* haguichi_join_create_network_dialog_new (const gchar* _mode);
VALA_EXTERN HaguichiJoinCreateNetworkDialog* haguichi_join_create_network_dialog_construct (GType object_type,
                                                                                const gchar* _mode);
VALA_EXTERN void haguichi_window_show_dialog (HaguichiWindow* self,
                                  GtkWindow* dialog);
static void haguichi_window_attach_action (HaguichiWindow* self);
VALA_EXTERN GType haguichi_attach_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiAttachDialog, g_object_unref)
VALA_EXTERN HaguichiAttachDialog* haguichi_attach_dialog_new (void);
VALA_EXTERN HaguichiAttachDialog* haguichi_attach_dialog_construct (GType object_type);
static void haguichi_window_attach_cancel_action (HaguichiWindow* self);
static void* __lambda132_ (HaguichiWindow* self);
VALA_EXTERN gchar* haguichi_hamachi_cancel (void);
static gpointer ___lambda132__gthread_func (gpointer self);
VALA_EXTERN void haguichi_sidebar_set_account (HaguichiSidebar* self,
                                   const gchar* account);
static void haguichi_window_start_search_action (HaguichiWindow* self);
static void haguichi_window_refresh_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_init (void);
VALA_EXTERN void haguichi_controller_update_connection (void);
static void haguichi_window_toggle_sidebar_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_toggle_sidebar (HaguichiWindow* self);
static void haguichi_window_cycle_mode_action (HaguichiWindow* self);
VALA_EXTERN gchar* haguichi_window_get_mode (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_set_mode (HaguichiWindow* self,
                               const gchar* mode);
VALA_EXTERN void haguichi_window_expand_all_networks_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_network_list_set_all_rows_expanded (HaguichiNetworkList* self,
                                                  gboolean expanded);
VALA_EXTERN void haguichi_window_collapse_all_networks_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_preferences_action (HaguichiWindow* self);
VALA_EXTERN GType haguichi_preferences_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiPreferences, g_object_unref)
VALA_EXTERN HaguichiPreferences* haguichi_preferences_new (void);
VALA_EXTERN HaguichiPreferences* haguichi_preferences_construct (GType object_type);
static void haguichi_window_shortcuts_action (HaguichiWindow* self);
static void haguichi_window_help_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_info_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_show_info (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_about_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_quit_action (HaguichiWindow* self);
VALA_EXTERN void haguichi_controller_quit (void);
VALA_EXTERN GType haguichi_connection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiConnection, g_object_unref)
VALA_EXTERN void haguichi_connection_save_long_nicks (HaguichiConnection* self);
static gboolean __lambda43_ (HaguichiWindow* self);
static gboolean ___lambda43__gtk_window_close_request (GtkWindow* _sender,
                                                gpointer self);
VALA_EXTERN void haguichi_window_show_toast (HaguichiWindow* self,
                                 const gchar* title,
                                 guint timeout);
VALA_EXTERN void haguichi_window_show_copied_to_clipboard_toast (HaguichiWindow* self);
VALA_EXTERN void haguichi_network_list_unselect (HaguichiNetworkList* self);
VALA_EXTERN void haguichi_window_show_sidebar (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_hide_sidebar (HaguichiWindow* self);
VALA_EXTERN void haguichi_window_set_connected_stack_page (HaguichiWindow* self,
                                               const gchar* page);
VALA_EXTERN void haguichi_sidebar_show_page (HaguichiSidebar* self,
                                 const gchar* page);
VALA_EXTERN void haguichi_window_set_background_status (HaguichiWindow* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN void haguichi_window_set_background_status_finish (HaguichiWindow* self,
                                                   GAsyncResult* _res_);
static void haguichi_window_set_background_status_data_free (gpointer _data);
static gboolean haguichi_window_set_background_status_co (HaguichiWindowSetBackgroundStatusData* _data_);
static void haguichi_window_set_background_status_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
VALA_EXTERN void haguichi_indicator_update_status (HaguichiIndicator* self,
                                       const gchar* mode,
                                       gboolean modal,
                                       gboolean visible);
static void haguichi_window_real_hide (GtkWidget* base);
static gboolean haguichi_window_real_close_request (GtkWindow* base);
VALA_EXTERN void haguichi_window_request_background (HaguichiWindow* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
VALA_EXTERN gboolean haguichi_window_request_background_finish (HaguichiWindow* self,
                                                    GAsyncResult* _res_);
static void ___lambda133_ (HaguichiWindow* self,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda133__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void haguichi_window_request_background_data_free (gpointer _data);
static gboolean haguichi_window_request_background_co (HaguichiWindowRequestBackgroundData* _data_);
static void haguichi_window_request_background_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void _vala_XdpParent_free (XdpParent* self);
static GObject * haguichi_window_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void haguichi_window_finalize (GObject * obj);
static GType haguichi_window_get_type_once (void);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
haguichi_window_get_instance_private (HaguichiWindow* self)
{
	return G_STRUCT_MEMBER_P (self, HaguichiWindow_private_offset);
}

static void
__lambda127_ (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
#line 100 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 100 "../src/window.vala"
	haguichi_network_list_refilter (_tmp0_);
#line 452 "window.c"
}

static void
___lambda127__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                               gpointer self)
{
#line 99 "../src/window.vala"
	__lambda127_ ((HaguichiWindow*) self);
#line 461 "window.c"
}

static void
__lambda128_ (HaguichiWindow* self)
{
	HaguichiSession* _tmp0_;
#line 104 "../src/window.vala"
	_tmp0_ = haguichi_session;
#line 104 "../src/window.vala"
	g_signal_emit_by_name (_tmp0_, "visibility-changed", FALSE);
#line 105 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 474 "window.c"
}

static void
___lambda128__gtk_widget_hide (GtkWidget* _sender,
                               gpointer self)
{
#line 103 "../src/window.vala"
	__lambda128_ ((HaguichiWindow*) self);
#line 483 "window.c"
}

static void
__lambda129_ (HaguichiWindow* self)
{
	HaguichiSession* _tmp0_;
#line 108 "../src/window.vala"
	_tmp0_ = haguichi_session;
#line 108 "../src/window.vala"
	g_signal_emit_by_name (_tmp0_, "visibility-changed", TRUE);
#line 109 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 496 "window.c"
}

static void
___lambda129__gtk_widget_show (GtkWidget* _sender,
                               gpointer self)
{
#line 107 "../src/window.vala"
	__lambda129_ ((HaguichiWindow*) self);
#line 505 "window.c"
}

HaguichiWindow*
haguichi_window_construct (GType object_type,
                           HaguichiApplication* app)
{
	HaguichiWindow * self = NULL;
	const gchar* _tmp0_;
	GSettings* config = NULL;
	GSettings* _tmp1_;
	GSettings* list = NULL;
	GSettings* _tmp2_;
	GSettings* ui = NULL;
	GSettings* _tmp3_;
	gchar* _tmp4_ = NULL;
	GAction* sort_by = NULL;
	GSettings* _tmp10_;
	GAction* _tmp11_;
	GAction* _tmp12_;
	GAction* show_offline_members = NULL;
	GSettings* _tmp13_;
	GAction* _tmp14_;
	GAction* _tmp15_;
	GSettings* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	GSettings* _tmp19_;
	GSettings* _tmp20_;
	GSettings* _tmp21_;
	GSettings* _tmp22_;
	HaguichiIndicator* _tmp23_;
	HaguichiIndicator* _tmp24_;
	GSettings* _tmp25_;
	GtkSearchEntry* _tmp26_;
#line 63 "../src/window.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 64 "../src/window.vala"
	self = (HaguichiWindow*) g_object_new (object_type, "application", app, "title", CONFIG_APP_NAME, NULL);
#line 67 "../src/window.vala"
	_tmp0_ = haguichi_current_desktop;
#line 67 "../src/window.vala"
	if (g_strcmp0 (_tmp0_, "KDE") != 0) {
#line 68 "../src/window.vala"
		gtk_window_set_icon_name ((GtkWindow*) self, CONFIG_APP_ID);
#line 550 "window.c"
	}
#line 71 "../src/window.vala"
	_tmp1_ = g_settings_new (CONFIG_APP_ID ".config");
#line 71 "../src/window.vala"
	config = _tmp1_;
#line 72 "../src/window.vala"
	_tmp2_ = g_settings_new (CONFIG_APP_ID ".network-list");
#line 72 "../src/window.vala"
	list = _tmp2_;
#line 73 "../src/window.vala"
	_tmp3_ = g_settings_new (CONFIG_APP_ID ".ui");
#line 73 "../src/window.vala"
	ui = _tmp3_;
#line 75 "../src/window.vala"
	if (haguichi_demo_mode) {
#line 566 "window.c"
		gchar* _tmp5_;
#line 75 "../src/window.vala"
		_tmp5_ = g_strdup ("Joe Demo");
#line 75 "../src/window.vala"
		_g_free0 (_tmp4_);
#line 75 "../src/window.vala"
		_tmp4_ = _tmp5_;
#line 574 "window.c"
	} else {
		GSettings* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 75 "../src/window.vala"
		_tmp6_ = config;
#line 75 "../src/window.vala"
		_tmp7_ = g_settings_get_string (_tmp6_, "nickname");
#line 75 "../src/window.vala"
		_tmp8_ = _tmp7_;
#line 75 "../src/window.vala"
		_tmp9_ = haguichi_utils_parse_nick (_tmp8_);
#line 75 "../src/window.vala"
		_g_free0 (_tmp4_);
#line 75 "../src/window.vala"
		_tmp4_ = _tmp9_;
#line 75 "../src/window.vala"
		_g_free0 (_tmp8_);
#line 594 "window.c"
	}
#line 75 "../src/window.vala"
	haguichi_window_set_nick (self, _tmp4_);
#line 77 "../src/window.vala"
	_tmp10_ = list;
#line 77 "../src/window.vala"
	_tmp11_ = g_settings_create_action (_tmp10_, "sort-by");
#line 77 "../src/window.vala"
	sort_by = _tmp11_;
#line 78 "../src/window.vala"
	_tmp12_ = sort_by;
#line 78 "../src/window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp12_);
#line 80 "../src/window.vala"
	_tmp13_ = list;
#line 80 "../src/window.vala"
	_tmp14_ = g_settings_create_action (_tmp13_, "show-offline-members");
#line 80 "../src/window.vala"
	show_offline_members = _tmp14_;
#line 81 "../src/window.vala"
	_tmp15_ = show_offline_members;
#line 81 "../src/window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp15_);
#line 83 "../src/window.vala"
	_tmp16_ = ui;
#line 83 "../src/window.vala"
	haguichi_application_set_color_scheme (app, (gint) g_settings_get_enum (_tmp16_, "color-scheme"));
#line 85 "../src/window.vala"
	_tmp18_ = _tmp17_ = g_get_language_names ();
#line 85 "../src/window.vala"
	if (g_strv_contains (_tmp18_, "ru")) {
#line 86 "../src/window.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "custom");
#line 628 "window.c"
	}
#line 89 "../src/window.vala"
	_tmp19_ = ui;
#line 89 "../src/window.vala"
	g_object_set ((GtkWindow*) self, "default-width", g_settings_get_int (_tmp19_, "width"), NULL);
#line 90 "../src/window.vala"
	_tmp20_ = ui;
#line 90 "../src/window.vala"
	g_object_set ((GtkWindow*) self, "default-height", g_settings_get_int (_tmp20_, "height"), NULL);
#line 92 "../src/window.vala"
	_tmp21_ = ui;
#line 92 "../src/window.vala"
	g_settings_bind (_tmp21_, "width", (GObject*) self, "default-width", G_SETTINGS_BIND_DEFAULT);
#line 93 "../src/window.vala"
	_tmp22_ = ui;
#line 93 "../src/window.vala"
	g_settings_bind (_tmp22_, "height", (GObject*) self, "default-height", G_SETTINGS_BIND_DEFAULT);
#line 95 "../src/window.vala"
	_tmp23_ = haguichi_indicator_new ();
#line 95 "../src/window.vala"
	_haguichi_indicator_unref0 (haguichi_indicator);
#line 95 "../src/window.vala"
	haguichi_indicator = _tmp23_;
#line 96 "../src/window.vala"
	_tmp24_ = haguichi_indicator;
#line 96 "../src/window.vala"
	_tmp25_ = ui;
#line 96 "../src/window.vala"
	haguichi_indicator_set_active (_tmp24_, g_settings_get_boolean (_tmp25_, "show-indicator"));
#line 97 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 99 "../src/window.vala"
	_tmp26_ = self->search_entry;
#line 99 "../src/window.vala"
	g_signal_connect_object (_tmp26_, "search-changed", (GCallback) ___lambda127__gtk_search_entry_search_changed, self, 0);
#line 103 "../src/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "hide", (GCallback) ___lambda128__gtk_widget_hide, self, 0);
#line 107 "../src/window.vala"
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) ___lambda129__gtk_widget_show, self, 0);
#line 63 "../src/window.vala"
	_g_object_unref0 (show_offline_members);
#line 63 "../src/window.vala"
	_g_object_unref0 (sort_by);
#line 63 "../src/window.vala"
	_g_free0 (_tmp4_);
#line 63 "../src/window.vala"
	_g_object_unref0 (ui);
#line 63 "../src/window.vala"
	_g_object_unref0 (list);
#line 63 "../src/window.vala"
	_g_object_unref0 (config);
#line 63 "../src/window.vala"
	return self;
#line 682 "window.c"
}

HaguichiWindow*
haguichi_window_new (HaguichiApplication* app)
{
#line 63 "../src/window.vala"
	return haguichi_window_construct (HAGUICHI_TYPE_WINDOW, app);
#line 690 "window.c"
}

static void
haguichi_window_download_hamachi (HaguichiWindow* self)
{
#line 135 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/window.vala"
	haguichi_command_open_redirect_uri ("get-hamachi");
#line 700 "window.c"
}

static void
_haguichi_window_download_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 17 "../src/window.vala"
	haguichi_window_download_hamachi ((HaguichiWindow*) self);
#line 709 "window.c"
}

static void
haguichi_window_configure_hamachi (HaguichiWindow* self)
{
	AdwWindowTitle* _tmp0_;
	GtkButton* _tmp1_;
#line 140 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/window.vala"
	_tmp0_ = self->window_title;
#line 141 "../src/window.vala"
	adw_window_title_set_subtitle (_tmp0_, _ ("Configuring"));
#line 142 "../src/window.vala"
	_tmp1_ = self->priv->configure_button;
#line 142 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 143 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.refresh", FALSE);
#line 144 "../src/window.vala"
	if (!haguichi_demo_mode) {
#line 145 "../src/window.vala"
		haguichi_hamachi_configure ();
#line 733 "window.c"
	}
}

static void
_haguichi_window_configure_hamachi_gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 17 "../src/window.vala"
	haguichi_window_configure_hamachi ((HaguichiWindow*) self);
#line 743 "window.c"
}

static void
haguichi_window_go_back_button_clicked (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
#line 150 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 151 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, FALSE);
#line 756 "window.c"
}

static void
_haguichi_window_go_back_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 17 "../src/window.vala"
	haguichi_window_go_back_button_clicked ((HaguichiWindow*) self);
#line 765 "window.c"
}

void
haguichi_window_connect_action (HaguichiWindow* self)
{
#line 154 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/window.vala"
	haguichi_controller_start_hamachi ();
#line 775 "window.c"
}

void
haguichi_window_disconnect_action (HaguichiWindow* self)
{
#line 158 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/window.vala"
	haguichi_controller_stop_hamachi ();
#line 785 "window.c"
}

void
haguichi_window_join_network_action (HaguichiWindow* self)
{
#line 162 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/window.vala"
	haguichi_window_add_network_action (self, "Join");
#line 795 "window.c"
}

void
haguichi_window_create_network_action (HaguichiWindow* self)
{
#line 166 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/window.vala"
	haguichi_window_add_network_action (self, "Create");
#line 805 "window.c"
}

static void
haguichi_window_add_network_action (HaguichiWindow* self,
                                    const gchar* mode)
{
	HaguichiJoinCreateNetworkDialog* add_network = NULL;
	HaguichiJoinCreateNetworkDialog* _tmp0_;
#line 170 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/window.vala"
	g_return_if_fail (mode != NULL);
#line 171 "../src/window.vala"
	_tmp0_ = haguichi_join_create_network_dialog_new (mode);
#line 171 "../src/window.vala"
	g_object_ref_sink (_tmp0_);
#line 171 "../src/window.vala"
	add_network = _tmp0_;
#line 172 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWindow*) add_network);
#line 170 "../src/window.vala"
	_g_object_unref0 (add_network);
#line 828 "window.c"
}

static void
haguichi_window_attach_action (HaguichiWindow* self)
{
	HaguichiAttachDialog* attach = NULL;
	HaguichiAttachDialog* _tmp0_;
#line 175 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/window.vala"
	_tmp0_ = haguichi_attach_dialog_new ();
#line 176 "../src/window.vala"
	g_object_ref_sink (_tmp0_);
#line 176 "../src/window.vala"
	attach = _tmp0_;
#line 177 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWindow*) attach);
#line 175 "../src/window.vala"
	_g_object_unref0 (attach);
#line 848 "window.c"
}

static void*
__lambda132_ (HaguichiWindow* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	void* result;
#line 182 "../src/window.vala"
	_tmp0_ = haguichi_hamachi_cancel ();
#line 182 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 182 "../src/window.vala"
	_g_free0 (_tmp1_);
#line 183 "../src/window.vala"
	result = NULL;
#line 183 "../src/window.vala"
	return result;
#line 867 "window.c"
}

static gpointer
___lambda132__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda132_ ((HaguichiWindow*) self);
#line 181 "../src/window.vala"
	g_object_unref (self);
#line 181 "../src/window.vala"
	return result;
#line 879 "window.c"
}

static void
haguichi_window_attach_cancel_action (HaguichiWindow* self)
{
	GThread* _tmp0_;
	GThread* _tmp1_;
	HaguichiSidebar* _tmp2_;
#line 180 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/window.vala"
	_tmp0_ = g_thread_new (NULL, ___lambda132__gthread_func, g_object_ref (self));
#line 181 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 181 "../src/window.vala"
	_g_thread_unref0 (_tmp1_);
#line 186 "../src/window.vala"
	_tmp2_ = self->sidebar;
#line 186 "../src/window.vala"
	haguichi_sidebar_set_account (_tmp2_, "-");
#line 900 "window.c"
}

static void
haguichi_window_start_search_action (HaguichiWindow* self)
{
	GtkSearchBar* _tmp0_;
#line 189 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/window.vala"
	_tmp0_ = self->search_bar;
#line 190 "../src/window.vala"
	g_object_set (_tmp0_, "search-mode-enabled", TRUE, NULL);
#line 913 "window.c"
}

static void
haguichi_window_refresh_action (HaguichiWindow* self)
{
#line 193 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/window.vala"
	if (haguichi_controller_last_status <= 1) {
#line 195 "../src/window.vala"
		haguichi_controller_init ();
#line 925 "window.c"
	} else {
#line 196 "../src/window.vala"
		if (haguichi_controller_last_status >= 6) {
#line 197 "../src/window.vala"
			haguichi_controller_update_connection ();
#line 931 "window.c"
		}
	}
}

static void
haguichi_window_toggle_sidebar_action (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 201 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 202 "../src/window.vala"
	_tmp1_ = adw_overlay_split_view_get_collapsed (_tmp0_);
#line 202 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 202 "../src/window.vala"
	if (_tmp2_ == FALSE) {
#line 202 "../src/window.vala"
		return;
#line 954 "window.c"
	}
#line 204 "../src/window.vala"
	haguichi_window_toggle_sidebar (self);
#line 958 "window.c"
}

static void
haguichi_window_cycle_mode_action (HaguichiWindow* self)
{
	gchar* cur_mode = NULL;
	gchar* _tmp0_;
	gchar* new_mode = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label0 = 0;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label1 = 0;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label2 = 0;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label3 = 0;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label4 = 0;
#line 212 "../src/window.vala"
	static GQuark _tmp4_label5 = 0;
#line 983 "window.c"
	const gchar* _tmp12_;
	const gchar* _tmp13_;
#line 207 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/window.vala"
	if (!haguichi_demo_mode) {
#line 208 "../src/window.vala"
		return;
#line 992 "window.c"
	}
#line 210 "../src/window.vala"
	_tmp0_ = haguichi_window_get_mode (self);
#line 210 "../src/window.vala"
	cur_mode = _tmp0_;
#line 211 "../src/window.vala"
	_tmp1_ = g_strdup ("");
#line 211 "../src/window.vala"
	new_mode = _tmp1_;
#line 212 "../src/window.vala"
	_tmp2_ = cur_mode;
#line 212 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 212 "../src/window.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 212 "../src/window.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("Initializing")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1012 "window.c"
			default:
			{
				gchar* _tmp6_;
#line 214 "../src/window.vala"
				_tmp6_ = g_strdup ("Disconnected");
#line 214 "../src/window.vala"
				_g_free0 (new_mode);
#line 214 "../src/window.vala"
				new_mode = _tmp6_;
#line 215 "../src/window.vala"
				break;
#line 1024 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("Disconnected")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1030 "window.c"
			default:
			{
				gchar* _tmp7_;
#line 217 "../src/window.vala"
				_tmp7_ = g_strdup ("Connecting");
#line 217 "../src/window.vala"
				_g_free0 (new_mode);
#line 217 "../src/window.vala"
				new_mode = _tmp7_;
#line 218 "../src/window.vala"
				break;
#line 1042 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("Connecting")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1048 "window.c"
			default:
			{
				gchar* _tmp8_;
#line 220 "../src/window.vala"
				_tmp8_ = g_strdup ("Connected");
#line 220 "../src/window.vala"
				_g_free0 (new_mode);
#line 220 "../src/window.vala"
				new_mode = _tmp8_;
#line 221 "../src/window.vala"
				break;
#line 1060 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label3) ? _tmp4_label3 : (_tmp4_label3 = g_quark_from_static_string ("Connected")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1066 "window.c"
			default:
			{
				gchar* _tmp9_;
#line 223 "../src/window.vala"
				_tmp9_ = g_strdup ("Not installed");
#line 223 "../src/window.vala"
				_g_free0 (new_mode);
#line 223 "../src/window.vala"
				new_mode = _tmp9_;
#line 224 "../src/window.vala"
				break;
#line 1078 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label4) ? _tmp4_label4 : (_tmp4_label4 = g_quark_from_static_string ("Not installed")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1084 "window.c"
			default:
			{
				gchar* _tmp10_;
#line 226 "../src/window.vala"
				_tmp10_ = g_strdup ("Not configured");
#line 226 "../src/window.vala"
				_g_free0 (new_mode);
#line 226 "../src/window.vala"
				new_mode = _tmp10_;
#line 227 "../src/window.vala"
				break;
#line 1096 "window.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label5) ? _tmp4_label5 : (_tmp4_label5 = g_quark_from_static_string ("Not configured")))) {
#line 212 "../src/window.vala"
		switch (0) {
#line 1102 "window.c"
			default:
			{
				gchar* _tmp11_;
#line 229 "../src/window.vala"
				_tmp11_ = g_strdup ("Initializing");
#line 229 "../src/window.vala"
				_g_free0 (new_mode);
#line 229 "../src/window.vala"
				new_mode = _tmp11_;
#line 230 "../src/window.vala"
				break;
#line 1114 "window.c"
			}
		}
	}
#line 233 "../src/window.vala"
	_tmp12_ = new_mode;
#line 233 "../src/window.vala"
	g_debug ("window.vala:233: new mode: %s", _tmp12_);
#line 234 "../src/window.vala"
	_tmp13_ = new_mode;
#line 234 "../src/window.vala"
	haguichi_window_set_mode (self, _tmp13_);
#line 207 "../src/window.vala"
	_g_free0 (new_mode);
#line 207 "../src/window.vala"
	_g_free0 (cur_mode);
#line 1130 "window.c"
}

void
haguichi_window_expand_all_networks_action (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
#line 237 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 238 "../src/window.vala"
	haguichi_network_list_set_all_rows_expanded (_tmp0_, TRUE);
#line 1143 "window.c"
}

void
haguichi_window_collapse_all_networks_action (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
#line 241 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 242 "../src/window.vala"
	haguichi_network_list_set_all_rows_expanded (_tmp0_, FALSE);
#line 1156 "window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 246 "../src/window.vala"
	return self ? g_object_ref (self) : NULL;
#line 1164 "window.c"
}

void
haguichi_window_preferences_action (HaguichiWindow* self)
{
	HaguichiPreferences* prefs = NULL;
	HaguichiApplication* _tmp0_;
	GtkApplication* _tmp1_;
	HaguichiPreferences* _tmp2_ = NULL;
#line 245 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/window.vala"
	_tmp0_ = haguichi_app;
#line 246 "../src/window.vala"
	_tmp1_ = _g_object_ref0 ((GtkApplication*) _tmp0_);
#line 246 "../src/window.vala"
	_tmp2_ = haguichi_preferences_new ();
#line 246 "../src/window.vala"
	gtk_window_set_application ((GtkWindow*) _tmp2_, _tmp1_);
#line 246 "../src/window.vala"
	_g_object_unref0 (_tmp1_);
#line 246 "../src/window.vala"
	g_object_ref_sink (_tmp2_);
#line 246 "../src/window.vala"
	prefs = _tmp2_;
#line 249 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWindow*) prefs);
#line 245 "../src/window.vala"
	_g_object_unref0 (prefs);
#line 1194 "window.c"
}

static void
haguichi_window_shortcuts_action (HaguichiWindow* self)
{
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	GtkShortcutsWindow* shortcuts = NULL;
	GObject* _tmp1_;
	GtkShortcutsWindow* _tmp2_;
#line 252 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/window.vala"
	_tmp0_ = gtk_builder_new_from_resource ("/com/github/ztefn/haguichi/ui/shortcuts.ui");
#line 253 "../src/window.vala"
	builder = _tmp0_;
#line 254 "../src/window.vala"
	_tmp1_ = gtk_builder_get_object (builder, "shortcuts");
#line 254 "../src/window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_shortcuts_window_get_type (), GtkShortcutsWindow));
#line 254 "../src/window.vala"
	shortcuts = _tmp2_;
#line 255 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWindow*) shortcuts);
#line 252 "../src/window.vala"
	_g_object_unref0 (shortcuts);
#line 252 "../src/window.vala"
	_g_object_unref0 (builder);
#line 1223 "window.c"
}

static void
haguichi_window_help_action (HaguichiWindow* self)
{
#line 258 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 259 "../src/window.vala"
	haguichi_command_open_redirect_uri ("help");
#line 1233 "window.c"
}

void
haguichi_window_info_action (HaguichiWindow* self)
{
#line 262 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/window.vala"
	haguichi_window_show_info (self);
#line 1243 "window.c"
}

void
haguichi_window_about_action (HaguichiWindow* self)
{
	gchar* developer_name = NULL;
	gchar* _tmp0_;
	AdwAboutWindow* about = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	AdwAboutWindow* _tmp9_ = NULL;
#line 266 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/window.vala"
	_tmp0_ = g_strdup ("Stephen Brandt");
#line 267 "../src/window.vala"
	developer_name = _tmp0_;
#line 268 "../src/window.vala"
	_tmp1_ = g_strdup (CONFIG_APP_NAME);
#line 268 "../src/window.vala"
	_tmp2_ = g_strdup (CONFIG_APP_ID);
#line 268 "../src/window.vala"
	_tmp3_ = g_strdup (developer_name);
#line 268 "../src/window.vala"
	_tmp4_ = g_strdup (_ ("translator-credits"));
#line 268 "../src/window.vala"
	_tmp5_ = g_strdup (CONFIG_VERSION);
#line 268 "../src/window.vala"
	_tmp6_ = g_strdup ("https://haguichi.net");
#line 268 "../src/window.vala"
	_tmp7_ = g_strdup ("https://github.com/ztefn/haguichi/issues");
#line 268 "../src/window.vala"
	_tmp8_ = g_strconcat ("© 2007-2024 ", developer_name, NULL);
#line 268 "../src/window.vala"
	_tmp9_ = (AdwAboutWindow*) adw_about_window_new ();
#line 268 "../src/window.vala"
	adw_about_window_set_application_name (_tmp9_, _tmp1_);
#line 268 "../src/window.vala"
	_g_free0 (_tmp1_);
#line 268 "../src/window.vala"
	adw_about_window_set_application_icon (_tmp9_, _tmp2_);
#line 268 "../src/window.vala"
	_g_free0 (_tmp2_);
#line 268 "../src/window.vala"
	adw_about_window_set_developer_name (_tmp9_, _tmp3_);
#line 268 "../src/window.vala"
	_g_free0 (_tmp3_);
#line 268 "../src/window.vala"
	adw_about_window_set_translator_credits (_tmp9_, _tmp4_);
#line 268 "../src/window.vala"
	_g_free0 (_tmp4_);
#line 268 "../src/window.vala"
	adw_about_window_set_version (_tmp9_, _tmp5_);
#line 268 "../src/window.vala"
	_g_free0 (_tmp5_);
#line 268 "../src/window.vala"
	adw_about_window_set_website (_tmp9_, _tmp6_);
#line 268 "../src/window.vala"
	_g_free0 (_tmp6_);
#line 268 "../src/window.vala"
	adw_about_window_set_issue_url (_tmp9_, _tmp7_);
#line 268 "../src/window.vala"
	_g_free0 (_tmp7_);
#line 268 "../src/window.vala"
	adw_about_window_set_copyright (_tmp9_, _tmp8_);
#line 268 "../src/window.vala"
	_g_free0 (_tmp8_);
#line 268 "../src/window.vala"
	adw_about_window_set_license_type (_tmp9_, GTK_LICENSE_GPL_3_0);
#line 268 "../src/window.vala"
	g_object_ref_sink (_tmp9_);
#line 268 "../src/window.vala"
	about = _tmp9_;
#line 280 "../src/window.vala"
	haguichi_window_show_dialog (self, (GtkWindow*) about);
#line 266 "../src/window.vala"
	_g_object_unref0 (about);
#line 266 "../src/window.vala"
	_g_free0 (developer_name);
#line 1329 "window.c"
}

void
haguichi_window_quit_action (HaguichiWindow* self)
{
	GtkWindow* _tmp0_;
	HaguichiConnection* _tmp2_;
	HaguichiSession* _tmp3_;
	HaguichiApplication* _tmp4_;
#line 283 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/window.vala"
	haguichi_controller_quit ();
#line 286 "../src/window.vala"
	_tmp0_ = self->modal_dialog;
#line 286 "../src/window.vala"
	if (_tmp0_ != NULL) {
#line 1347 "window.c"
		GtkWindow* _tmp1_;
#line 287 "../src/window.vala"
		_tmp1_ = self->modal_dialog;
#line 287 "../src/window.vala"
		gtk_window_destroy (_tmp1_);
#line 1353 "window.c"
	}
#line 290 "../src/window.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 292 "../src/window.vala"
	_tmp2_ = haguichi_connection;
#line 292 "../src/window.vala"
	haguichi_connection_save_long_nicks (_tmp2_);
#line 293 "../src/window.vala"
	_tmp3_ = haguichi_session;
#line 293 "../src/window.vala"
	g_signal_emit_by_name (_tmp3_, "quitted");
#line 295 "../src/window.vala"
	g_debug ("window.vala:295: quit_action: Bye!");
#line 296 "../src/window.vala"
	_tmp4_ = haguichi_app;
#line 296 "../src/window.vala"
	g_application_quit ((GApplication*) _tmp4_);
#line 1371 "window.c"
}

static gboolean
__lambda43_ (HaguichiWindow* self)
{
	HaguichiSession* _tmp0_;
	gboolean result;
#line 302 "../src/window.vala"
	_g_object_unref0 (self->modal_dialog);
#line 302 "../src/window.vala"
	self->modal_dialog = NULL;
#line 303 "../src/window.vala"
	_tmp0_ = haguichi_session;
#line 303 "../src/window.vala"
	g_signal_emit_by_name (_tmp0_, "modality-changed", FALSE);
#line 304 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 305 "../src/window.vala"
	result = FALSE;
#line 305 "../src/window.vala"
	return result;
#line 1393 "window.c"
}

static gboolean
___lambda43__gtk_window_close_request (GtkWindow* _sender,
                                       gpointer self)
{
	gboolean result;
	result = __lambda43_ ((HaguichiWindow*) self);
#line 301 "../src/window.vala"
	return result;
#line 1404 "window.c"
}

void
haguichi_window_show_dialog (HaguichiWindow* self,
                             GtkWindow* dialog)
{
	GtkWindow* _tmp0_;
	HaguichiSession* _tmp1_;
#line 299 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 299 "../src/window.vala"
	g_return_if_fail (dialog != NULL);
#line 300 "../src/window.vala"
	gtk_window_set_transient_for (dialog, (GtkWindow*) self);
#line 301 "../src/window.vala"
	g_signal_connect_object (dialog, "close-request", (GCallback) ___lambda43__gtk_window_close_request, self, 0);
#line 307 "../src/window.vala"
	gtk_window_present (dialog);
#line 309 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (dialog);
#line 309 "../src/window.vala"
	_g_object_unref0 (self->modal_dialog);
#line 309 "../src/window.vala"
	self->modal_dialog = _tmp0_;
#line 310 "../src/window.vala"
	_tmp1_ = haguichi_session;
#line 310 "../src/window.vala"
	g_signal_emit_by_name (_tmp1_, "modality-changed", TRUE);
#line 311 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 1435 "window.c"
}

void
haguichi_window_show_toast (HaguichiWindow* self,
                            const gchar* title,
                            guint timeout)
{
	AdwToastOverlay* _tmp0_;
	AdwToast* _tmp1_ = NULL;
#line 314 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 314 "../src/window.vala"
	g_return_if_fail (title != NULL);
#line 315 "../src/window.vala"
	_tmp0_ = self->priv->toast_overlay;
#line 315 "../src/window.vala"
	_tmp1_ = adw_toast_new (title);
#line 315 "../src/window.vala"
	adw_toast_set_timeout (_tmp1_, timeout);
#line 315 "../src/window.vala"
	adw_toast_overlay_add_toast (_tmp0_, _tmp1_);
#line 1457 "window.c"
}

void
haguichi_window_show_copied_to_clipboard_toast (HaguichiWindow* self)
{
#line 320 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/window.vala"
	haguichi_window_show_toast (self, _ ("Copied to clipboard"), (guint) 2);
#line 1467 "window.c"
}

void
haguichi_window_show_info (HaguichiWindow* self)
{
	HaguichiNetworkList* _tmp0_;
	AdwOverlaySplitView* _tmp1_;
#line 324 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 325 "../src/window.vala"
	_tmp0_ = self->network_list;
#line 325 "../src/window.vala"
	haguichi_network_list_unselect (_tmp0_);
#line 326 "../src/window.vala"
	_tmp1_ = self->split_view;
#line 326 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp1_, TRUE);
#line 1485 "window.c"
}

void
haguichi_window_toggle_sidebar (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	AdwOverlaySplitView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 329 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 330 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 330 "../src/window.vala"
	_tmp1_ = self->split_view;
#line 330 "../src/window.vala"
	_tmp2_ = adw_overlay_split_view_get_show_sidebar (_tmp1_);
#line 330 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 330 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, !_tmp3_);
#line 1507 "window.c"
}

void
haguichi_window_show_sidebar (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	AdwOverlaySplitView* _tmp3_;
#line 333 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 334 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 334 "../src/window.vala"
	g_object_get ((GtkWindow*) self, "default-width", &_tmp1_, NULL);
#line 334 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 334 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, _tmp2_ > 520);
#line 335 "../src/window.vala"
	_tmp3_ = self->split_view;
#line 335 "../src/window.vala"
	adw_overlay_split_view_set_pin_sidebar (_tmp3_, FALSE);
#line 1531 "window.c"
}

void
haguichi_window_hide_sidebar (HaguichiWindow* self)
{
	AdwOverlaySplitView* _tmp0_;
	AdwOverlaySplitView* _tmp1_;
#line 338 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/window.vala"
	_tmp0_ = self->split_view;
#line 339 "../src/window.vala"
	adw_overlay_split_view_set_show_sidebar (_tmp0_, FALSE);
#line 340 "../src/window.vala"
	_tmp1_ = self->split_view;
#line 340 "../src/window.vala"
	adw_overlay_split_view_set_pin_sidebar (_tmp1_, TRUE);
#line 1549 "window.c"
}

void
haguichi_window_set_nick (HaguichiWindow* self,
                          const gchar* nick)
{
	const gchar* _tmp0_ = NULL;
	AdwWindowTitle* _tmp1_;
#line 343 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 343 "../src/window.vala"
	g_return_if_fail (nick != NULL);
#line 344 "../src/window.vala"
	if (g_strcmp0 (nick, "") == 0) {
#line 344 "../src/window.vala"
		_tmp0_ = _ ("Anonymous");
#line 1566 "window.c"
	} else {
#line 344 "../src/window.vala"
		_tmp0_ = nick;
#line 1570 "window.c"
	}
#line 344 "../src/window.vala"
	_tmp1_ = self->window_title;
#line 344 "../src/window.vala"
	adw_window_title_set_title (_tmp1_, _tmp0_);
#line 1576 "window.c"
}

void
haguichi_window_set_connected_stack_page (HaguichiWindow* self,
                                          const gchar* page)
{
	GtkStack* _tmp0_;
#line 347 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/window.vala"
	g_return_if_fail (page != NULL);
#line 348 "../src/window.vala"
	_tmp0_ = self->connected_stack;
#line 348 "../src/window.vala"
	gtk_stack_set_visible_child_name (_tmp0_, page);
#line 1592 "window.c"
}

gchar*
haguichi_window_get_mode (HaguichiWindow* self)
{
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 351 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 352 "../src/window.vala"
	_tmp0_ = self->stack;
#line 352 "../src/window.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 352 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 352 "../src/window.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 352 "../src/window.vala"
	result = _tmp3_;
#line 352 "../src/window.vala"
	return result;
#line 1617 "window.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1636 "window.c"
}

void
haguichi_window_set_mode (HaguichiWindow* self,
                          const gchar* mode)
{
	HaguichiSession* _tmp0_;
	GtkStack* _tmp1_;
	gboolean is_configured = FALSE;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	GtkButton* _tmp6_;
	GtkToggleButton* _tmp14_;
	gboolean _tmp15_ = FALSE;
	GtkToggleButton* _tmp16_;
	GtkToggleButton* _tmp17_;
	GtkToggleButton* _tmp18_;
	GtkSearchBar* _tmp19_;
	GtkSpinner* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkMenuButton* _tmp28_;
#line 355 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 355 "../src/window.vala"
	g_return_if_fail (mode != NULL);
#line 356 "../src/window.vala"
	_tmp0_ = haguichi_session;
#line 356 "../src/window.vala"
	g_signal_emit_by_name (_tmp0_, "mode-changed", mode);
#line 358 "../src/window.vala"
	_tmp1_ = self->stack;
#line 358 "../src/window.vala"
	gtk_stack_set_visible_child_name (_tmp1_, mode);
#line 360 "../src/window.vala"
	_tmp2_ = g_utf8_strdown (mode, (gssize) -1);
#line 360 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 360 "../src/window.vala"
	_tmp4_ = string_contains (_tmp3_, "connect");
#line 360 "../src/window.vala"
	_g_free0 (_tmp3_);
#line 360 "../src/window.vala"
	is_configured = _tmp4_;
#line 362 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.connect", g_strcmp0 (mode, "Disconnected") == 0);
#line 363 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.disconnect", g_strcmp0 (mode, "Connected") == 0);
#line 364 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.join-network", g_strcmp0 (mode, "Connected") == 0);
#line 365 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.create-network", g_strcmp0 (mode, "Connected") == 0);
#line 366 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.start-search", g_strcmp0 (mode, "Connected") == 0);
#line 367 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.refresh", TRUE);
#line 368 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.toggle-sidebar", is_configured);
#line 369 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.info", is_configured);
#line 370 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.sort-by", is_configured);
#line 371 "../src/window.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "win.show-offline-members", is_configured);
#line 373 "../src/window.vala"
	if (g_strcmp0 (mode, "Not installed") == 0) {
#line 373 "../src/window.vala"
		_tmp5_ = TRUE;
#line 1707 "window.c"
	} else {
#line 373 "../src/window.vala"
		_tmp5_ = g_strcmp0 (mode, "Not configured") == 0;
#line 1711 "window.c"
	}
#line 373 "../src/window.vala"
	_tmp6_ = self->priv->refresh_button;
#line 373 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, _tmp5_);
#line 375 "../src/window.vala"
	if (g_strcmp0 (mode, "Not installed") == 0) {
#line 1719 "window.c"
		gboolean _tmp7_ = FALSE;
#line 376 "../src/window.vala"
		if (haguichi_demo_mode) {
#line 376 "../src/window.vala"
			_tmp7_ = TRUE;
#line 1725 "window.c"
		} else {
			const gchar* _tmp8_;
#line 376 "../src/window.vala"
			_tmp8_ = haguichi_hamachi_version;
#line 376 "../src/window.vala"
			_tmp7_ = g_strcmp0 (_tmp8_, "") == 0;
#line 1732 "window.c"
		}
#line 376 "../src/window.vala"
		if (_tmp7_) {
#line 1736 "window.c"
			AdwStatusPage* _tmp9_;
#line 377 "../src/window.vala"
			_tmp9_ = self->not_installed_status_page;
#line 377 "../src/window.vala"
			adw_status_page_set_title (_tmp9_, _ ("Hamachi Is Not Installed"));
#line 1742 "window.c"
		} else {
			AdwStatusPage* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 379 "../src/window.vala"
			_tmp10_ = self->not_installed_status_page;
#line 379 "../src/window.vala"
			_tmp11_ = haguichi_hamachi_version;
#line 379 "../src/window.vala"
			_tmp12_ = g_strdup_printf (_ ("Hamachi Version %s Is Obsolete"), _tmp11_);
#line 379 "../src/window.vala"
			_tmp13_ = _tmp12_;
#line 379 "../src/window.vala"
			adw_status_page_set_title (_tmp10_, _tmp13_);
#line 379 "../src/window.vala"
			_g_free0 (_tmp13_);
#line 1760 "window.c"
		}
	}
#line 383 "../src/window.vala"
	_tmp14_ = self->connect_button;
#line 383 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp14_, g_strcmp0 (mode, "Disconnected") == 0);
#line 384 "../src/window.vala"
	if (g_strcmp0 (mode, "Connecting") == 0) {
#line 384 "../src/window.vala"
		_tmp15_ = TRUE;
#line 1771 "window.c"
	} else {
#line 384 "../src/window.vala"
		_tmp15_ = g_strcmp0 (mode, "Connected") == 0;
#line 1775 "window.c"
	}
#line 384 "../src/window.vala"
	_tmp16_ = self->disconnect_button;
#line 384 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp16_, _tmp15_);
#line 386 "../src/window.vala"
	_tmp17_ = self->search_button;
#line 386 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp17_, is_configured);
#line 387 "../src/window.vala"
	_tmp18_ = self->search_button;
#line 387 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp18_, g_strcmp0 (mode, "Connected") == 0);
#line 388 "../src/window.vala"
	_tmp19_ = self->search_bar;
#line 388 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, g_strcmp0 (mode, "Connected") == 0);
#line 389 "../src/window.vala"
	if (g_strcmp0 (mode, "Connected") != 0) {
#line 1795 "window.c"
		GtkSearchBar* _tmp20_;
#line 390 "../src/window.vala"
		_tmp20_ = self->search_bar;
#line 390 "../src/window.vala"
		g_object_set (_tmp20_, "search-mode-enabled", FALSE, NULL);
#line 1801 "window.c"
	}
#line 393 "../src/window.vala"
	if (is_configured) {
#line 1805 "window.c"
		HaguichiSidebar* _tmp21_;
		GtkButton* _tmp22_;
		HaguichiSidebar* _tmp23_;
		GtkButton* _tmp24_;
#line 394 "../src/window.vala"
		_tmp21_ = self->sidebar;
#line 394 "../src/window.vala"
		_tmp22_ = _tmp21_->attach_button;
#line 394 "../src/window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, g_strcmp0 (mode, "Connected") == 0);
#line 395 "../src/window.vala"
		_tmp23_ = self->sidebar;
#line 395 "../src/window.vala"
		_tmp24_ = _tmp23_->cancel_button;
#line 395 "../src/window.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, g_strcmp0 (mode, "Connected") == 0);
#line 396 "../src/window.vala"
		haguichi_window_show_sidebar (self);
#line 1824 "window.c"
	} else {
#line 398 "../src/window.vala"
		haguichi_window_hide_sidebar (self);
#line 1828 "window.c"
	}
#line 401 "../src/window.vala"
	_tmp25_ = self->spinner;
#line 401 "../src/window.vala"
	gtk_spinner_set_spinning (_tmp25_, g_strcmp0 (mode, "Connecting") == 0);
#line 403 "../src/window.vala"
	_tmp26_ = self->priv->configure_button;
#line 403 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, g_strcmp0 (mode, "Not configured") == 0);
#line 405 "../src/window.vala"
	_tmp27_ = self->priv->overlay_refresh_button;
#line 405 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp27_, g_strcmp0 (mode, "Connected") == 0);
#line 406 "../src/window.vala"
	_tmp28_ = self->priv->overlay_add_network_button;
#line 406 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp28_, g_strcmp0 (mode, "Connected") == 0);
#line 408 "../src/window.vala"
	if (g_strcmp0 (mode, "Initializing") == 0) {
#line 1848 "window.c"
		AdwWindowTitle* _tmp29_;
#line 409 "../src/window.vala"
		_tmp29_ = self->window_title;
#line 409 "../src/window.vala"
		adw_window_title_set_subtitle (_tmp29_, _ ("Initializing"));
#line 1854 "window.c"
	} else {
#line 410 "../src/window.vala"
		if (g_strcmp0 (mode, "Connecting") == 0) {
#line 1858 "window.c"
			AdwWindowTitle* _tmp30_;
#line 411 "../src/window.vala"
			_tmp30_ = self->window_title;
#line 411 "../src/window.vala"
			adw_window_title_set_subtitle (_tmp30_, _ ("Connecting"));
#line 1864 "window.c"
		} else {
#line 412 "../src/window.vala"
			if (g_strcmp0 (mode, "Connected") == 0) {
#line 1868 "window.c"
				AdwWindowTitle* _tmp31_;
#line 413 "../src/window.vala"
				_tmp31_ = self->window_title;
#line 413 "../src/window.vala"
				adw_window_title_set_subtitle (_tmp31_, _ ("Connected"));
#line 1874 "window.c"
			} else {
				AdwWindowTitle* _tmp32_;
				HaguichiSidebar* _tmp33_;
#line 415 "../src/window.vala"
				_tmp32_ = self->window_title;
#line 415 "../src/window.vala"
				adw_window_title_set_subtitle (_tmp32_, _ ("Disconnected"));
#line 416 "../src/window.vala"
				_tmp33_ = self->sidebar;
#line 416 "../src/window.vala"
				haguichi_sidebar_show_page (_tmp33_, "Information");
#line 1886 "window.c"
			}
		}
	}
#line 420 "../src/window.vala"
	if (xdp_portal_running_under_flatpak ()) {
#line 421 "../src/window.vala"
		haguichi_window_set_background_status (self, NULL, NULL);
#line 1894 "window.c"
	}
#line 424 "../src/window.vala"
	haguichi_window_update_indicator_status (self);
#line 1898 "window.c"
}

static void
haguichi_window_set_background_status_data_free (gpointer _data)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
	_data_ = _data;
#line 17 "../src/window.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/window.vala"
	g_slice_free (HaguichiWindowSetBackgroundStatusData, _data_);
#line 1910 "window.c"
}

void
haguichi_window_set_background_status (HaguichiWindow* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
	HaguichiWindow* _tmp0_;
#line 17 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/window.vala"
	_data_ = g_slice_new0 (HaguichiWindowSetBackgroundStatusData);
#line 17 "../src/window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 17 "../src/window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, haguichi_window_set_background_status_data_free);
#line 17 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/window.vala"
	_data_->self = _tmp0_;
#line 17 "../src/window.vala"
	haguichi_window_set_background_status_co (_data_);
#line 1934 "window.c"
}

void
haguichi_window_set_background_status_finish (HaguichiWindow* self,
                                              GAsyncResult* _res_)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
#line 17 "../src/window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1944 "window.c"
}

static void
haguichi_window_set_background_status_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	HaguichiWindowSetBackgroundStatusData* _data_;
#line 429 "../src/window.vala"
	_data_ = _user_data_;
#line 429 "../src/window.vala"
	_data_->_source_object_ = source_object;
#line 429 "../src/window.vala"
	_data_->_res_ = _res_;
#line 429 "../src/window.vala"
	haguichi_window_set_background_status_co (_data_);
#line 1961 "window.c"
}

static gboolean
haguichi_window_set_background_status_co (HaguichiWindowSetBackgroundStatusData* _data_)
{
#line 427 "../src/window.vala"
	switch (_data_->_state_) {
#line 427 "../src/window.vala"
		case 0:
#line 1971 "window.c"
		goto _state_0;
#line 427 "../src/window.vala"
		case 1:
#line 1975 "window.c"
		goto _state_1;
		default:
#line 427 "../src/window.vala"
		g_assert_not_reached ();
#line 1980 "window.c"
	}
	_state_0:
	{
#line 429 "../src/window.vala"
		_data_->_tmp0_ = _data_->self->priv->portal;
#line 429 "../src/window.vala"
		_data_->_tmp1_ = _data_->self->window_title;
#line 429 "../src/window.vala"
		_data_->_tmp2_ = adw_window_title_get_subtitle (_data_->_tmp1_);
#line 429 "../src/window.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 429 "../src/window.vala"
		_data_->_state_ = 1;
#line 429 "../src/window.vala"
		xdp_portal_set_background_status (_data_->_tmp0_, _data_->_tmp3_, NULL, haguichi_window_set_background_status_ready, _data_);
#line 429 "../src/window.vala"
		return FALSE;
#line 1998 "window.c"
		_state_1:
#line 429 "../src/window.vala"
		_data_->success = xdp_portal_set_background_status_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 429 "../src/window.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2004 "window.c"
			goto __catch0_g_error;
		}
#line 430 "../src/window.vala"
		if (!_data_->success) {
#line 431 "../src/window.vala"
			g_warning ("window.vala:431: set_background_status: Updating background status fai" \
"led");
#line 2011 "window.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 428 "../src/window.vala"
		_data_->e = _data_->_inner_error0_;
#line 428 "../src/window.vala"
		_data_->_inner_error0_ = NULL;
#line 434 "../src/window.vala"
		_data_->_tmp4_ = _data_->e;
#line 434 "../src/window.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 434 "../src/window.vala"
		g_critical ("window.vala:434: set_background_status: %s", _data_->_tmp5_);
#line 428 "../src/window.vala"
		_g_error_free0 (_data_->e);
#line 2029 "window.c"
	}
	__finally0:
#line 428 "../src/window.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 428 "../src/window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 428 "../src/window.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 428 "../src/window.vala"
		g_object_unref (_data_->_async_result);
#line 428 "../src/window.vala"
		return FALSE;
#line 2042 "window.c"
	}
#line 427 "../src/window.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 427 "../src/window.vala"
	if (_data_->_state_ != 0) {
#line 427 "../src/window.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 427 "../src/window.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2052 "window.c"
		}
	}
#line 427 "../src/window.vala"
	g_object_unref (_data_->_async_result);
#line 427 "../src/window.vala"
	return FALSE;
#line 2059 "window.c"
}

void
haguichi_window_update_indicator_status (HaguichiWindow* self)
{
	HaguichiIndicator* _tmp0_;
#line 438 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 439 "../src/window.vala"
	_tmp0_ = haguichi_indicator;
#line 439 "../src/window.vala"
	if (_tmp0_ != NULL) {
#line 2072 "window.c"
		HaguichiIndicator* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GtkWindow* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 440 "../src/window.vala"
		_tmp1_ = haguichi_indicator;
#line 440 "../src/window.vala"
		_tmp2_ = haguichi_window_get_mode (self);
#line 440 "../src/window.vala"
		_tmp3_ = _tmp2_;
#line 440 "../src/window.vala"
		_tmp4_ = self->modal_dialog;
#line 440 "../src/window.vala"
		_tmp5_ = gtk_widget_get_visible ((GtkWidget*) self);
#line 440 "../src/window.vala"
		_tmp6_ = _tmp5_;
#line 440 "../src/window.vala"
		haguichi_indicator_update_status (_tmp1_, _tmp3_, _tmp4_ != NULL, _tmp6_);
#line 440 "../src/window.vala"
		_g_free0 (_tmp3_);
#line 2095 "window.c"
	}
}

static void
haguichi_window_real_hide (GtkWidget* base)
{
	HaguichiWindow * self;
	GtkWindow* _tmp0_;
#line 444 "../src/window.vala"
	self = (HaguichiWindow*) base;
#line 445 "../src/window.vala"
	_tmp0_ = self->modal_dialog;
#line 445 "../src/window.vala"
	if (_tmp0_ == NULL) {
#line 446 "../src/window.vala"
		GTK_WIDGET_CLASS (haguichi_window_parent_class)->hide ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow));
#line 2112 "window.c"
	}
}

static void
___lambda133_ (HaguichiWindow* self,
               GObject* obj,
               GAsyncResult* res)
{
#line 454 "../src/window.vala"
	g_return_if_fail (res != NULL);
#line 455 "../src/window.vala"
	if (haguichi_window_request_background_finish (self, res)) {
#line 456 "../src/window.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 2127 "window.c"
	} else {
#line 458 "../src/window.vala"
		gtk_window_destroy ((GtkWindow*) self);
#line 2131 "window.c"
	}
}

static void
____lambda133__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 454 "../src/window.vala"
	___lambda133_ ((HaguichiWindow*) self, source_object, res);
#line 454 "../src/window.vala"
	g_object_unref (self);
#line 2144 "window.c"
}

static gboolean
haguichi_window_real_close_request (GtkWindow* base)
{
	HaguichiWindow * self;
	gchar* mode = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result;
#line 450 "../src/window.vala"
	self = (HaguichiWindow*) base;
#line 452 "../src/window.vala"
	_tmp0_ = haguichi_window_get_mode (self);
#line 452 "../src/window.vala"
	mode = _tmp0_;
#line 453 "../src/window.vala"
	_tmp2_ = mode;
#line 453 "../src/window.vala"
	if (g_strcmp0 (_tmp2_, "Connecting") == 0) {
#line 453 "../src/window.vala"
		_tmp1_ = TRUE;
#line 2168 "window.c"
	} else {
		const gchar* _tmp3_;
#line 453 "../src/window.vala"
		_tmp3_ = mode;
#line 453 "../src/window.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "Connected") == 0;
#line 2175 "window.c"
	}
#line 453 "../src/window.vala"
	if (_tmp1_) {
#line 454 "../src/window.vala"
		haguichi_window_request_background (self, ____lambda133__gasync_ready_callback, g_object_ref (self));
#line 2181 "window.c"
	} else {
#line 462 "../src/window.vala"
		gtk_window_destroy ((GtkWindow*) self);
#line 2185 "window.c"
	}
#line 465 "../src/window.vala"
	result = TRUE;
#line 465 "../src/window.vala"
	_g_free0 (mode);
#line 465 "../src/window.vala"
	return result;
#line 2193 "window.c"
}

static void
haguichi_window_request_background_data_free (gpointer _data)
{
	HaguichiWindowRequestBackgroundData* _data_;
	_data_ = _data;
#line 17 "../src/window.vala"
	_g_object_unref0 (_data_->self);
#line 17 "../src/window.vala"
	g_slice_free (HaguichiWindowRequestBackgroundData, _data_);
#line 2205 "window.c"
}

void
haguichi_window_request_background (HaguichiWindow* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	HaguichiWindowRequestBackgroundData* _data_;
	HaguichiWindow* _tmp0_;
#line 17 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 17 "../src/window.vala"
	_data_ = g_slice_new0 (HaguichiWindowRequestBackgroundData);
#line 17 "../src/window.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 17 "../src/window.vala"
	g_task_set_task_data (_data_->_async_result, _data_, haguichi_window_request_background_data_free);
#line 17 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 17 "../src/window.vala"
	_data_->self = _tmp0_;
#line 17 "../src/window.vala"
	haguichi_window_request_background_co (_data_);
#line 2229 "window.c"
}

gboolean
haguichi_window_request_background_finish (HaguichiWindow* self,
                                           GAsyncResult* _res_)
{
	gboolean result;
	HaguichiWindowRequestBackgroundData* _data_;
#line 17 "../src/window.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 17 "../src/window.vala"
	result = _data_->result;
#line 17 "../src/window.vala"
	return result;
#line 2244 "window.c"
}

static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 476 "../src/window.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 2252 "window.c"
}

static void
haguichi_window_request_background_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	HaguichiWindowRequestBackgroundData* _data_;
#line 476 "../src/window.vala"
	_data_ = _user_data_;
#line 476 "../src/window.vala"
	_data_->_source_object_ = source_object;
#line 476 "../src/window.vala"
	_data_->_res_ = _res_;
#line 476 "../src/window.vala"
	haguichi_window_request_background_co (_data_);
#line 2269 "window.c"
}

static void
_vala_XdpParent_free (XdpParent* self)
{
#line 476 "../src/window.vala"
	g_boxed_free (xdp_parent_get_type (), self);
#line 2277 "window.c"
}

static gboolean
haguichi_window_request_background_co (HaguichiWindowRequestBackgroundData* _data_)
{
#line 468 "../src/window.vala"
	switch (_data_->_state_) {
#line 468 "../src/window.vala"
		case 0:
#line 2287 "window.c"
		goto _state_0;
#line 468 "../src/window.vala"
		case 1:
#line 2291 "window.c"
		goto _state_1;
		default:
#line 468 "../src/window.vala"
		g_assert_not_reached ();
#line 2296 "window.c"
	}
	_state_0:
#line 469 "../src/window.vala"
	_data_->_tmp0_ = xdp_parent_new_gtk ((GtkWindow*) _data_->self);
#line 469 "../src/window.vala"
	_data_->parent = _data_->_tmp0_;
#line 471 "../src/window.vala"
	_data_->_tmp1_ = g_ptr_array_new_full ((guint) 0, NULL);
#line 471 "../src/window.vala"
	_data_->command = _data_->_tmp1_;
#line 472 "../src/window.vala"
	g_ptr_array_add (_data_->command, CONFIG_APP_ID);
#line 473 "../src/window.vala"
	g_ptr_array_add (_data_->command, "--background");
#line 2311 "window.c"
	{
#line 476 "../src/window.vala"
		_data_->_tmp3_ = _data_->self->priv->portal;
#line 476 "../src/window.vala"
		_data_->_tmp4_ = _g_ptr_array_ref0 (_data_->command);
#line 476 "../src/window.vala"
		_data_->_state_ = 1;
#line 476 "../src/window.vala"
		xdp_portal_request_background (_data_->_tmp3_, _data_->parent, _ ("Haguichi will continue to run when its window is closed so that it can" \
" monitor the connection and send notifications."), _data_->_tmp4_, XDP_BACKGROUND_FLAG_NONE, NULL, haguichi_window_request_background_ready, _data_);
#line 476 "../src/window.vala"
		return FALSE;
#line 2323 "window.c"
		_state_1:
#line 476 "../src/window.vala"
		_data_->_tmp2_ = xdp_portal_request_background_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 476 "../src/window.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2329 "window.c"
			goto __catch0_g_error;
		}
#line 476 "../src/window.vala"
		_data_->result = _data_->_tmp2_;
#line 476 "../src/window.vala"
		_g_ptr_array_unref0 (_data_->command);
#line 476 "../src/window.vala"
		__vala_XdpParent_free0 (_data_->parent);
#line 476 "../src/window.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 476 "../src/window.vala"
		if (_data_->_state_ != 0) {
#line 476 "../src/window.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 476 "../src/window.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2346 "window.c"
			}
		}
#line 476 "../src/window.vala"
		g_object_unref (_data_->_async_result);
#line 476 "../src/window.vala"
		return FALSE;
#line 2353 "window.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 475 "../src/window.vala"
		_data_->e = _data_->_inner_error0_;
#line 475 "../src/window.vala"
		_data_->_inner_error0_ = NULL;
#line 484 "../src/window.vala"
		_data_->_tmp5_ = _data_->e;
#line 484 "../src/window.vala"
		_data_->_tmp6_ = _data_->_tmp5_->message;
#line 484 "../src/window.vala"
		g_critical ("window.vala:484: request_background: %s", _data_->_tmp6_);
#line 486 "../src/window.vala"
		_data_->result = TRUE;
#line 486 "../src/window.vala"
		_g_error_free0 (_data_->e);
#line 486 "../src/window.vala"
		_g_ptr_array_unref0 (_data_->command);
#line 486 "../src/window.vala"
		__vala_XdpParent_free0 (_data_->parent);
#line 486 "../src/window.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 486 "../src/window.vala"
		if (_data_->_state_ != 0) {
#line 486 "../src/window.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 486 "../src/window.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2384 "window.c"
			}
		}
#line 486 "../src/window.vala"
		g_object_unref (_data_->_async_result);
#line 486 "../src/window.vala"
		return FALSE;
#line 2391 "window.c"
	}
	__finally0:
#line 475 "../src/window.vala"
	_g_ptr_array_unref0 (_data_->command);
#line 475 "../src/window.vala"
	__vala_XdpParent_free0 (_data_->parent);
#line 475 "../src/window.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 475 "../src/window.vala"
	g_clear_error (&_data_->_inner_error0_);
#line 475 "../src/window.vala"
	g_object_unref (_data_->_async_result);
#line 475 "../src/window.vala"
	return FALSE;
#line 2406 "window.c"
}

static GObject *
haguichi_window_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HaguichiWindow * self;
#line 113 "../src/window.vala"
	parent_class = G_OBJECT_CLASS (haguichi_window_parent_class);
#line 113 "../src/window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 113 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_WINDOW, HaguichiWindow);
#line 114 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.connect", NULL, (GtkWidgetActionActivateFunc) haguichi_window_connect_action);
#line 115 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.disconnect", NULL, (GtkWidgetActionActivateFunc) haguichi_window_disconnect_action);
#line 116 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.join-network", NULL, (GtkWidgetActionActivateFunc) haguichi_window_join_network_action);
#line 117 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.create-network", NULL, (GtkWidgetActionActivateFunc) haguichi_window_create_network_action);
#line 118 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.attach", NULL, (GtkWidgetActionActivateFunc) haguichi_window_attach_action);
#line 119 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.attach-cancel", NULL, (GtkWidgetActionActivateFunc) haguichi_window_attach_cancel_action);
#line 120 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.start-search", NULL, (GtkWidgetActionActivateFunc) haguichi_window_start_search_action);
#line 121 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.refresh", NULL, (GtkWidgetActionActivateFunc) haguichi_window_refresh_action);
#line 122 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.toggle-sidebar", NULL, (GtkWidgetActionActivateFunc) haguichi_window_toggle_sidebar_action);
#line 123 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.cycle-mode", NULL, (GtkWidgetActionActivateFunc) haguichi_window_cycle_mode_action);
#line 124 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.expand-all-networks", NULL, (GtkWidgetActionActivateFunc) haguichi_window_expand_all_networks_action);
#line 125 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.collapse-all-networks", NULL, (GtkWidgetActionActivateFunc) haguichi_window_collapse_all_networks_action);
#line 126 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.preferences", NULL, (GtkWidgetActionActivateFunc) haguichi_window_preferences_action);
#line 127 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.shortcuts", NULL, (GtkWidgetActionActivateFunc) haguichi_window_shortcuts_action);
#line 128 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.help", NULL, (GtkWidgetActionActivateFunc) haguichi_window_help_action);
#line 129 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.info", NULL, (GtkWidgetActionActivateFunc) haguichi_window_info_action);
#line 130 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.about", NULL, (GtkWidgetActionActivateFunc) haguichi_window_about_action);
#line 131 "../src/window.vala"
	gtk_widget_class_install_action (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), "win.quit", NULL, (GtkWidgetActionActivateFunc) haguichi_window_quit_action);
#line 113 "../src/window.vala"
	return obj;
#line 2461 "window.c"
}

static void
haguichi_window_class_init (HaguichiWindowClass * klass,
                            gpointer klass_data)
{
#line 17 "../src/window.vala"
	haguichi_window_parent_class = g_type_class_peek_parent (klass);
#line 17 "../src/window.vala"
	g_type_class_adjust_private_offset (klass, &HaguichiWindow_private_offset);
#line 17 "../src/window.vala"
	((GtkWidgetClass *) klass)->hide = (void (*) (GtkWidget*)) haguichi_window_real_hide;
#line 17 "../src/window.vala"
	((GtkWindowClass *) klass)->close_request = (gboolean (*) (GtkWindow*)) haguichi_window_real_close_request;
#line 17 "../src/window.vala"
	G_OBJECT_CLASS (klass)->constructor = haguichi_window_constructor;
#line 17 "../src/window.vala"
	G_OBJECT_CLASS (klass)->finalize = haguichi_window_finalize;
#line 17 "../src/window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/ztefn/haguichi/ui/window.ui");
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "toast_overlay", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, toast_overlay));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "split_view", FALSE, G_STRUCT_OFFSET (HaguichiWindow, split_view));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "window_title", FALSE, G_STRUCT_OFFSET (HaguichiWindow, window_title));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "not_installed_status_page", FALSE, G_STRUCT_OFFSET (HaguichiWindow, not_installed_status_page));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sidebar", FALSE, G_STRUCT_OFFSET (HaguichiWindow, sidebar));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "network_list", FALSE, G_STRUCT_OFFSET (HaguichiWindow, network_list));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "refresh_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, refresh_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connect_button", FALSE, G_STRUCT_OFFSET (HaguichiWindow, connect_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "disconnect_button", FALSE, G_STRUCT_OFFSET (HaguichiWindow, disconnect_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_button", FALSE, G_STRUCT_OFFSET (HaguichiWindow, search_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_bar", FALSE, G_STRUCT_OFFSET (HaguichiWindow, search_bar));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "search_entry", FALSE, G_STRUCT_OFFSET (HaguichiWindow, search_entry));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, G_STRUCT_OFFSET (HaguichiWindow, stack));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "connected_stack", FALSE, G_STRUCT_OFFSET (HaguichiWindow, connected_stack));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "spinner", FALSE, G_STRUCT_OFFSET (HaguichiWindow, spinner));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "configure_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, configure_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay_refresh_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, overlay_refresh_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "overlay_add_network_button", FALSE, HaguichiWindow_private_offset + G_STRUCT_OFFSET (HaguichiWindowPrivate, overlay_add_network_button));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "download_hamachi", G_CALLBACK(_haguichi_window_download_hamachi_gtk_button_clicked));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "configure_hamachi", G_CALLBACK(_haguichi_window_configure_hamachi_gtk_button_clicked));
#line 17 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "go_back_button_clicked", G_CALLBACK(_haguichi_window_go_back_button_clicked_gtk_button_clicked));
#line 2524 "window.c"
}

static void
haguichi_window_instance_init (HaguichiWindow * self,
                               gpointer klass)
{
	XdpPortal* _tmp0_;
#line 17 "../src/window.vala"
	self->priv = haguichi_window_get_instance_private (self);
#line 59 "../src/window.vala"
	_tmp0_ = xdp_portal_new ();
#line 59 "../src/window.vala"
	self->priv->portal = _tmp0_;
#line 17 "../src/window.vala"
	g_type_ensure (HAGUICHI_TYPE_SIDEBAR);
#line 17 "../src/window.vala"
	g_type_ensure (HAGUICHI_TYPE_NETWORK_LIST);
#line 17 "../src/window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2544 "window.c"
}

static void
haguichi_window_finalize (GObject * obj)
{
	HaguichiWindow * self;
#line 17 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, HAGUICHI_TYPE_WINDOW, HaguichiWindow);
#line 59 "../src/window.vala"
	_g_object_unref0 (self->priv->portal);
#line 61 "../src/window.vala"
	_g_object_unref0 (self->modal_dialog);
#line 17 "../src/window.vala"
	G_OBJECT_CLASS (haguichi_window_parent_class)->finalize (obj);
#line 2559 "window.c"
}

static GType
haguichi_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HaguichiWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) haguichi_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HaguichiWindow), 0, (GInstanceInitFunc) haguichi_window_instance_init, NULL };
	GType haguichi_window_type_id;
	haguichi_window_type_id = g_type_register_static (adw_application_window_get_type (), "HaguichiWindow", &g_define_type_info, 0);
	HaguichiWindow_private_offset = g_type_add_instance_private (haguichi_window_type_id, sizeof (HaguichiWindowPrivate));
	return haguichi_window_type_id;
}

GType
haguichi_window_get_type (void)
{
	static volatile gsize haguichi_window_type_id__once = 0;
	if (g_once_init_enter (&haguichi_window_type_id__once)) {
		GType haguichi_window_type_id;
		haguichi_window_type_id = haguichi_window_get_type_once ();
		g_once_init_leave (&haguichi_window_type_id__once, haguichi_window_type_id);
	}
	return haguichi_window_type_id__once;
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

